/**
 * Gymky.me
 * Created by xavi on 13/10/15.
 */

var users = require('../../app/controllers/users.server.controller');
var activities = require('../../app/controllers/activities.server.controller');

module.exports = function( app ) {

    app.route('/api/activities')
        .get(activities.list)
        .post(users.requiresLogin, activities.create);

    app.route('/api/activities/:activityId')
        .get(activities.read)
        .put(users.requiresLogin, activities.update)
        .delete(users.requiresLogin, activities.delete);

    app.route('/api/activities/teams/:activityId')
        .get(activities.readTeam);

    app.route('/api/activities/login/:activityId/:leaderEmail')
        .get(activities.activityByLeaderEmail);

    app.route('/api/activities/email/:activityId')
        .get(activities.sendMail);

    app.route('/api/activities/task/:activityId/:task/:userId')
        .get(activities.taskByID);

    app.route('/api/activities/question/:activityId/:task/:response/:userId')
        .get(activities.activityQuestionResponse);

    app.route('/api/activities/results/:activityId/:userId')
        .get(activities.getResults);

    app.route('/api/activities/:activityId/background')
        .put(activities.updateBackground);

    app.route('/api/activities/background/:activityId/:task/:userId')
        .put(activities.updateTaskBackground);

    app.param('activityId', activities.activityByID);

};
