/**
 * Created by xavi on 10/10/15.
 */
/**
 * Gulp Dependencies
 * @type {Gulp|exports}
 */
var gulp    = require('gulp'),
    clean   = require('gulp-clean'),
    buffer  = require('vinyl-buffer'),
    source  = require('vinyl-source-stream'),
    concat  = require('gulp-concat'),
    uglify  = require('gulp-uglify'),
    sass    = require('gulp-sass'),
    minify  = require('gulp-minify-css'),
    assign  = require('lodash.assign');

gulp.task('default', ['generate-js', 'generate-css']);

gulp.task('delete-app',function(){
    return gulp.src(['./public/*.js'])
        .pipe(clean());
});

gulp.task('generate-css', function () {
    return gulp.src('./public/scss/app.scss')
        .pipe(sass().on('error', sass.logError))
        .pipe(concat('app.css'))
        .pipe(minify())
        .pipe(gulp.dest('./public/css'));
});

gulp.task('generate-js', ['delete-app'], function () {

    console.log('Compress-JS init');

    return gulp.src([
        './node_modules/angular/angular.js',
        './node_modules/angular-ui-router/release/angular-ui-router.js',
        './node_modules/angular-resource/angular-resource.js',
        './node_modules/angular-animate/angular-animate.min.js',
        './node_modules/angular-aria/angular-aria.min.js',
        './node_modules/angular-file-upload/dist/angular-file-upload.js',
        './node_modules/jquery/dist/jquery.js',
        './node_modules/ng-file-upload/dist/ng-file-upload-shim.js',
        './node_modules/ng-file-upload/dist/ng-file-upload.js',
        './node_modules/angular-cookies/angular-cookies.js',
        './node_modules/angular-confirm/angular-confirm.js',

        './public/app/login/**/*.js',
        './public/app/menu/**/*.js',
        './public/app/users/**/*.js',
        './public/app/activities/**/*.js',
        './public/app/profile/**/*.js',
        './public/app/games/**/*.js',
        './public/app/app.js',
        './public/app/_config/app.config.js',
        './public/app/_config/app.run.js',
        './public/app/_config/routes/*.js'


    ])
    .pipe(concat('app.js'))
    .pipe(uglify())
    .pipe(gulp.dest('./public/'));
});

