/**
 * Initialize the environment
 * @type {string|*}
 */
process.env.NODE_ENV = process.env.NODE_ENV || 'development';

/**
 * Require dependencies
 */
var mongoose = require('./config/mongoose')
  , express = require('./config/express')
  , passport = require('./config/passport');

/**
 * Initialize the app
 */
var db = mongoose()
  , app = express()
  , passport = passport()
  , port = process.env.PORT || 3000;

module.exports = app;

app.listen(port, function() {
    console.log('%d listening on %d', process.pid, port);
});