/**
 * Gymky.me
 * Created by xavi on 13/10/15.
 */

(function() {

    'use strict';
    angular
        .module('activities')
        .factory('ActivitiesService', [
            '$resource',
            ActivitiesSrvFn
        ]);

    function ActivitiesSrvFn( $resource ) {

        var services = {};

        services.activity = $resource('api/activities/:activityId',
            {
                'activityId' : '@_id'
            },
            {
                'get'   :   { method : 'GET' },
                'save'  :   { method : 'POST' },
                'update':   { method : 'PUT' },
                'query' :   { method : 'GET', isArray: false },
                'remove':   { method:'DELETE' },
                'delete':   { method:'DELETE' }
            }
        );

        services.team = $resource('api/activities/teams/:activityId',
            { 'activityId' : '@_id' },
            { 'get' : { method: 'GET' } }
        );

        services.game = $resource('api/activities/login/:activityId/:leaderEmail',
            {
                'activityId'    : '@activityId',
                'leaderEmail'   : '@leaderEmail'
            },
            {
                'get' : { method: 'GET' }
            }
        );

        services.emails = $resource('api/activities/email/:activityId',
            { 'activityId' : '@_id' },
            { 'get' : { method: 'GET' } }
        );

        services.task = $resource('api/activities/task/:activityId/:task/:userId',
            {
                'activityId': '@_id',
                'task'      : '@task',
                'userId'    : '@userId'
            },
            {
                'get' : { method: 'GET' }
            }
        );

        services.question = $resource('api/activities/question/:activityId/:task/:response/:userId',
            {
                'activityId': '@_id',
                'task'      : '@taskId',
                'response'  : '@response',
                'userId'    : '@userId'
            },
            {
                'get'   : { method: 'GET' },
                'update': { method: 'PUT' }
            }
        );

        services.results = $resource('api/activities/results/:activityId/:userId',
            {
                'activityId': '@_id',
                'userId'    : '@userId'
            },
            {
                'query'   : { method: 'GET', isArray: true}
            }

        );

        return services;

    }

})();

