/**
 * Gymky.me
 * Created by xavi on 30/12/15.
 */

(function(){

    'use strict';
    angular
        .module('games')
        .controller('IntroductionGameCtrl', [
            '$cookies',
            '$state',
            '$stateParams',
            'ActivitiesService',
            IntroductionGameCtrlFn
        ]);

    function IntroductionGameCtrlFn( $cookies, $state, $stateParams, ActivitiesSrv ){

        var self = this;

        self.loading = true;
        self.user = $cookies.getObject( 'currentUser' );
        self.introduction = $cookies.getObject( 'gameIntroduction' );
        self.activityId = $stateParams.activityId;

        __checkAuthentication();

        self.responseHandlers = {

            getActivity: function( data ) {

                self.activity = data;
                self.loading = false;

            },
            startGame: function() {

                var gameIntroduction = { activityId : $stateParams.activityId };

                $cookies.putObject( 'gameIntroduction', gameIntroduction );

                $state.go('game.play', { activityId: $stateParams.activityId });
            }

        };

        self.findActivity = function() {

            __checkIntroduction();

            var defaultParams = { activityId : $stateParams.activityId };

            ActivitiesSrv.team.get(
                defaultParams,
                self.responseHandlers.getActivity,
                self.responseHandlers.unknownActivity
            );

        };

        self.startGame = function() {

            self.responseHandlers.startGame();

        };

        self.cancelGame = function() {

            $state.go('login');

        };

        function __checkAuthentication(){

            if ( angular.isUndefined( self.user ) ||
                self.user.gameId !== self.activityId  ) {

                $state.go( 'login' );

            }

        }

        function __checkIntroduction() {

            if ( angular.isDefined( self.introduction ) &&
                self.introduction.activityId === self.activityId ) {

                $state.go('game.play', { activityId: $stateParams.activityId });

            }
        }

    }

})();
